#!/bin/bash
#
# Description: 変数展開の基本パターン1
#              単純な展開, 間接参照, 同じ文字列ではじまる定義済み変数名

source pre.bash

echo "単純な展開"
var="pen"
echo '    I have a $var.' "→ I have a $var."
echo '    I have two ${var}s.' "→ I have two ${var}s." ' ;変数名の区切りが紛れる場合は、{}で変数名をくくる'
echo

echo '文字数'
var2="日本語も含むStrings"
echo '    ${#var}:' "var='$var' : length=${#var}"
echo '    ${#var2}:' "var='$var2' : length=${#var2}"
echo

echo "間接参照"
echo "    BASH=$BASH"
mybash="BASH"
echo "    mybash=$mybash"
echo "    私のbashは、${!mybash}" ' ${!mybash} $mybashを展開した結果が変数名の値'
echo

echo "コマンドライン引数"
echo "    このコマンド($BASH_SOURCE)を実行する時に引数をいくつか渡してみよう"
echo '    $0' " 実行中の「この」コマンド:'$0'"
echo '    $1' " 1番目の引数:'$1'"
echo '    $!#' " 最後の引数:'$!#'" ' $!#'
echo '    shift'
shift
echo '    $1' " 1番目の引数:'$1'"
echo

echo "同じ文字列ではじまる定義済み変数名"
echo '    ${!BASH*}' " BASHではじまる変数: '${!BASH*}'"
echo '    ${!BASH@}' " BASHではじまる変数: '${!BASH@}'"
echo

