#!/bin/bash
#
# Description: 変数展開の基本パターン3
#              文字列の加工2: 基本の切り出し, 位置指定による切り出し

source pre.bash

echo "文字列の加工2"

echo "    マッチングによる切り出し"
str="I have a pen. You have a pencil. She has a dog."
echo "        str=$str"
echo '        ${str#*en} 先頭からはじめにenにマッチするところまで削除:' " '${str#*en}'" 
echo '        ${str##*en} 先頭から最後にenにマッチするところまで削除:' " '${str##*en}'" 
echo '        ${str%en*} 末尾からはじめにenにマッチするところまで削除:' " '${str%en*}'" 
echo '        ${st%%en*} 末尾から最後にenにマッチするところまで削除:' " '${str%%en*}'" 
echo '        # % の後ろがパターン。パターン中*は任意の文字列。マッチング記号2つは、最長マッチということ'
echo

echo "    位置指定による切り出し (4.はbash4)"
echo '        開始位置は、「0」から数える。${str::2} ${str:2} のように省略した部分は0とみなす'
for str in "0123456789" "0一2三4五六7八9"
do
    echo "        str=$str"
    echo '        1. ${str:3:5} 先頭から3文字目から5文字:' " '${str:3:5}'"
    echo '        2. ${str: -4:2} 末尾から4文字目から右方向に2文字. はじめの:の直後にスペースが必要:' " '${str: -4:2}'" 
    echo '        3. ${str:(-4):2} 2.と同じ意味、右から4文字目から右方向に2文字. カッコでマイナス値をくくる。:' " '${str:(-4):2}'" 
    if [ ${BASH_VERSION%%.*} -lt 4 ]; then
        echo '        4. ${str:3:-2} 先頭から3文字目から、末尾から左に2文字目まで:' '${str:3:-2}'"← ☆bash3ではエラーになる"
    else
        echo '        4. ${str:3:-2} 先頭から3文字目から、末尾から左に2文字目まで:' " '${str:3:-2}'"
    fi
    echo

done
echo
