#!/bin/bash
#
# Description: 変数展開の基本パターン4
#              文字列の加工3: 置換と削除

source pre.bash

echo "文字列の加工3"
echo 'パターンには、任意の文字列*、任意の1文字?、範囲内の1文字[...]などがある'

echo "    置換と削除"
str="すももも、ももも、もものうち"
echo "        str='$str'"
echo '        ${str/もも/大根} はじめのパターンを置換: ' "'${str/もも/大根}'"
echo '        ${str//もも/大根} すべてのパターンを置換: ' "'${str//もも/大根}'"
echo '        ${str/もも} はじめのパターンを削除: ' "'${str/もも}'"
echo '        ${str//もも} すべてのパターンを削除: ' "'${str//もも}'"
echo
echo '        ${str/も*も/大根} 任意の文字列(*)にマッチを使ったパターンにマッチするはじめの1つ: ' "'${str/も*も/大根}'"
echo '        ${str//も*も/大根} 任意の文字列(*)にマッチを使ったパターンにマッチするすべて: ' "'${str//も*も/大根}'"
echo '        ${str/も?も/大根} 任意の1文字(?)にマッチするを使ったパターンにマッチするはじめの1つ: ' "'${str/も?も/大根}'"
echo '        ${str//も?も/大根} 任意の1文字(?)にマッチを使ったパターンにマッチするすべて: ' "'${str//も?も/大根}'"
echo
echo '        ${str/も[の-も]/大根} []を使ったパターンにマッチするはじめの1つ: ' "'${str/も[の-も]/大根}'"
echo '        ${str//も[の-も]/大根} []を使ったパターンにマッチするすべて: ' "'${str//も[の-も]/大根}'"
echo '        ${str/も[^の-も]/大根} 補集合[^]パターンを使ったパターンにマッチするはじめの1つ: ' "'${str/も[^の-も]/大根}'"
echo '        ${str//も[^の-も]/大根} 補集合[^]パターンを使ったパターンにマッチするすべて: ' "'${str//も[^の-も]/大根}'"
echo

for str in "ももも もももも" "すももも もももっち" "ももっち" "すもも"
do
    echo "        str='$str'"
    echo '        ${str/#もも/大根} 先頭パターンを置換: ' "'${str/#もも/大根}'"
    echo '        ${str/%もも/大根} 末尾パターンを置換: ' "'${str/%もも/大根}'"
done

echo
echo '[...]表記の基本;'
echo '       [A-Z]     : 文字コードで、AからZまでの任意の1文字にマッチ。この場合、アルファベット大文字'
echo '       [A-CM-O]  : こうも書ける。A,B,C,M,N,O のいずれか1文字にマッチ。'
echo '       [^A-Z]    : 補集合。AからZ以外の任意の1文字にマッチ。^の代わりに!でも同じ意味'
echo '       [aAbC]    : a, A, b もしくは　Cに1文字とマッチ'
echo '       [:CLASS:] : 文字クラス内の1文字。'
echo '                   CLASSには、Bashの公式ドキュメントによると以下があるが、ロケールなどに依存するので注意'
echo '                   alnum, alpha, ascii, blank, cntrl, digit, graph, lower, print, punct, space, upper, word, xdigit'

